/* eslint-disable jsx-a11y/no-static-element-interactions */
/* eslint-disable jsx-a11y/click-events-have-key-events */
/* eslint-disable react/no-array-index-key */
import React, { Component } from 'react';
import PropTypes from 'prop-types';

class Timer extends Component {
	constructor(props) {
		super(props);
		this.state = {
			timerDuration: 0
		};
	}

	componentDidMount = () => {
		if (
			this.props.timerDuration !== this.state.timerDuration &&
			this.state.timerDuration === 0
		) {
			if (this.timer) {
				clearInterval(this.timer);
			}
			this.setState({ timerDuration: this.props.timerDuration });
			this.handleStart();
		}
	};

	componentDidUpdate = prevProps => {
		if (this.props.timerDuration !== prevProps.timerDuration) {
			if (this.timer) {
				clearInterval(this.timer);
			}
			this.setState({ timerDuration: this.props.timerDuration });
			this.handleStart();
		}
	};

	componentWillUnmount() {
		if (this.timer) {
			clearInterval(this.timer);
		}
	}

	format = time => {
		let seconds = time % 60;
		let minutes = Math.floor(time / 60);
		minutes = minutes.toString().length === 1 ? `0${minutes}` : minutes;
		seconds = seconds.toString().length === 1 ? `0${seconds}` : seconds;
		return `${minutes}:${seconds}`;
	};

	handleStart = () => {
		this.timer = setInterval(() => {
			const newTimerDuration = this.state.timerDuration - 1;
			this.setState({
				timerDuration: newTimerDuration >= 0 ? newTimerDuration : 0
			});
		}, 1000);
	};

	render() {
		const { timerDuration } = this.state;
		return (
			<div>
				<div>
					{timerDuration && timerDuration > 0
						? this.format(timerDuration)
						: '00:00'}
				</div>
			</div>
		);
	}
}

Timer.propTypes = {
	timerDuration: PropTypes.number.isRequired
};

export default Timer;
