/* eslint-disable jsx-a11y/click-events-have-key-events */
/* eslint-disable jsx-a11y/no-static-element-interactions */
import React, { Component } from 'react';
import PropTypes from 'prop-types';

class ToDoForm extends Component {
	constructor(props) {
		super(props);
		this.state = {
			value: '',
			error: ''
		};
	}

	fieldChange = event => {
		this.setState({
			value: event.target.value
		});
	};

	handleOnKeyPress = event => {
		if (event.keyCode === 13) {
			this.addSite();
		}
	};

	addSite = () => {
		let { value } = this.state;
		const { items } = this.props;
		let error = '';
		let isDuplicate = false;
		if (value === '') {
			error = 'Please add task';
		}
		items.map(site => {
			if (site.value === value) {
				isDuplicate = true;
			}
			return null;
		});

		if (isDuplicate) {
			error = 'This task has already been added';
		}

		if (!error) {
			this.props.addItem({ newItemValue: value });
			value = '';
		}
		this.setState({ value, error });
	};

	render() {
		const { value, error } = this.state;
		return (
			<div>
				<div style={{ height: '15px' }}>
					{error !== '' && (
						<div
							style={{
								color: '#ffc264',
								textAlign: 'left',
								fontSize: '12px'
							}}
						>
							{error}
						</div>
					)}
				</div>
				<div className="todos-input-container">
					<div className="todos-input-wrapper">
						<input
							type="text"
							className="todos-input"
							placeholder="+ Add task"
							value={value}
							onChange={this.fieldChange}
							onKeyDown={this.handleOnKeyPress}
						/>
					</div>
					<div className="plus-icon-to-do" onClick={this.addSite}>
						<svg
							xmlns="http://www.w3.org/2000/svg"
							width="12.463"
							height="12.463"
							viewBox="0 0 12.463 12.463"
						>
							<g
								id="Group_115"
								data-name="Group 115"
								transform="translate(6.232 1) rotate(45)"
							>
								<line
									id="Line_22"
									data-name="Line 22"
									x2="7.399"
									y2="7.399"
									transform="translate(0 0)"
									fill="none"
									stroke="#fff"
									strokeLinecap="round"
									strokeWidth={1}
								/>
								<line
									id="Line_23"
									data-name="Line 23"
									y1="7.399"
									x2="7.399"
									transform="translate(0 0)"
									fill="none"
									stroke="#fff"
									strokeLinecap="round"
									strokeWidth={1}
								/>
							</g>
						</svg>
					</div>
				</div>
			</div>
		);
	}
}

ToDoForm.propTypes = {
	addItem: PropTypes.func.isRequired,
	items: PropTypes.array.isRequired
};

export default ToDoForm;
